#include "Info.h"

FunctionInfo::FunctionInfo(FuncDef *expr, ClassInfoPtr klass)
: VarInfo(expr->pident_, expr->type_), block(expr->block_), klass(klass)
{
	arguments.reserve(expr->listarg_->size());
	for (auto arg : *expr->listarg_) {
		arguments.emplace_back(make_shared<VarInfo>((Ar*)arg));
	}
}


Binding::Binding(shared_ptr<Binding> parent)
	: variables(parent ? &parent->variables : nullptr),
	classes(parent ? &parent->classes : nullptr, &variables),
	functions(parent ? &parent->functions : nullptr, &variables),
	parent(parent)
{

}



ClassInfo::ClassInfo(PIdent *ident, BindingPtr parent /*= nullptr*/)
	: VarInfo(ident),
	Binding(parent)
{

};

Scope::Scope()
	: currentClass()
{

}

